# coding: utf-8

"""
    PowerBot - Webservice for algotrading

    # TERMS AND CONDITIONS The Powerbot system provides B2B services for trading at intraday power markets. By using the Powerbot service, each user agrees to the terms and conditions of this licence: 1. The user confirms that he/she is familiar with the exchanges trading system and all relevant rules, is professionally qualified and in possession of a trading license for the relevant exchange. 2. The user will comply with the exchanges market rules (e.g. [EPEX Spot Market Rules](https://www.epexspot.com/en/extras/download-center/documentation) or [Nord Pool Market Rules](https://www.nordpoolgroup.com/trading/Rules-and-regulations/)) and will not endanger the exchange system at any time with heavy load from trading algorithms or by other use. 3. The user is aware of OTR (order-to-trade) limits and other limits imposed by the exchange. 4. The user is solely liable for actions resulting from the use of PowerBot.   # INTRODUCTION Powerbot is a web-based software service enabling algorithmic trading on intraday power exchanges such as EPEX, Nord Pool, HUPX, BSP Southpool or TGE. The service is straightforward to integrate in an existing software environment and provides a variety of programming interfaces for development of individual trading algorithms and software tools. Besides enabling fully automated intraday trading, it can be used to create tools for human traders providing relevant information and trading opportunities or can be integrated in existing software tools. For further details see https://www.powerbot-trading.com  ## DOCUMENTATION  In addition to this API guide, please find the documentation at https://docs.powerbot-trading.com - the password will be provided by the PowerBot team. If not, please reach out to us at support@powerbot-trading.com  ## Endpoints The Powerbot service is available at the following REST endpoints:  | Instance                | Base URL for REST Endpoints                                           | |-------------------------|-----------------------------------------------------------------------| | Test (EPEX)             | https://staging.powerbot-trading.com/playground/epex/v2/api           | | Test (Nord Pool)        | https://staging.powerbot-trading.com/playground/nordpool/v2/api       | | Test (HUPX)             | https://staging.powerbot-trading.com/playground/hupx/v2/api           | | Test (BSP Southpool)    | https://staging.powerbot-trading.com/playground/southpool/v2/api      | | Test (TGE)              | https://staging.powerbot-trading.com/playground/tge/v2/api            | | Test (IBEX)             | https://staging.powerbot-trading.com/playground/ibex/v2/api           | | Test (CROPEX)           | https://staging.powerbot-trading.com/playground/cropex/v2/api         | | Staging, Production     | Provided on request                                                   |  Access to endpoints is secured via an API Key, which needs to be passed as an \"api_key\" header in each request.   Notes on API Keys:  * API keys are specific to Test, Staging or Production.  * API keys are generated by the system administrator and need to be requested.  ## How to generate API clients (libraries) The API provides automated generation of API clients (programming libraries) for a wide range of programming languages. To generate them, please open Swagger Editor from the exchange menu, click on \"Generate Client\" and choose a programming language.  ## Errors The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be in JSON format as follows:  ``` {   \"message\": \"... an error message ...\" } ```  ## Paging The API uses offset and limit parameters for paged operations. An X-Total-Count header is added to responses to indicate the total number of items in a paged response.  ## Cross-Origin Resource Sharing This API features Cross-Origin Resource Sharing (CORS) implemented in compliance with  [W3C spec](https://www.w3.org/TR/cors/). This allows cross-domain communication from the browser. All responses have a wildcard same-origin which makes them completely public and accessible to everyone, including any code on any site.  ## API Rate Limiting The API limits the number of concurrent calls to 50 - when that limit is reached, the client will receive 503 http status codes (service unavailable) with the following text:  ``` {   \"message\": \"API rate limit exceeded\" } ``` Clients should ensure that they stay within the limit for concurrent API calls.  ## Additional code samples Additional information and code samples demonstrating the use of the API can be found at https://github.com/powerbot-trading.  # noqa: E501

    OpenAPI spec version: 2.1.25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from powerbot_asyncio_client.api_client import ApiClient


class CapacitiesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_capacities(self, delivery_area, delivery_from, delivery_to, **kwargs):  # noqa: E501
        """Retrieves the Hub-to-ATC matrix from XBID  # noqa: E501

        Retrievs the Hub-to-Hub ATC matrix from XBID. This feature is only available on M7 exchanges and needs to be explicity activated by the system administrator. The response has a client side cache of 30 seconds set. May only be called up to 4 times an hour per delivery area for initialization, as traffic intensity is high. Updates shall be received via the corresponding web socket subscription.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_capacities(delivery_area, delivery_from, delivery_to, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[str] delivery_area: The EIC codes of the delivery area(s). Filter is applied to \"from_delivery_area\". (required)
        :param datetime delivery_from: (required)
        :param datetime delivery_to: (required)
        :return: list[Capacity]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_capacities_with_http_info(delivery_area, delivery_from, delivery_to, **kwargs)  # noqa: E501
        else:
            (data) = self.get_capacities_with_http_info(delivery_area, delivery_from, delivery_to, **kwargs)  # noqa: E501
            return data

    def get_capacities_with_http_info(self, delivery_area, delivery_from, delivery_to, **kwargs):  # noqa: E501
        """Retrieves the Hub-to-ATC matrix from XBID  # noqa: E501

        Retrievs the Hub-to-Hub ATC matrix from XBID. This feature is only available on M7 exchanges and needs to be explicity activated by the system administrator. The response has a client side cache of 30 seconds set. May only be called up to 4 times an hour per delivery area for initialization, as traffic intensity is high. Updates shall be received via the corresponding web socket subscription.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_capacities_with_http_info(delivery_area, delivery_from, delivery_to, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[str] delivery_area: The EIC codes of the delivery area(s). Filter is applied to \"from_delivery_area\". (required)
        :param datetime delivery_from: (required)
        :param datetime delivery_to: (required)
        :return: list[Capacity]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['delivery_area', 'delivery_from', 'delivery_to']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_capacities" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'delivery_area' is set
        if ('delivery_area' not in params or
                params['delivery_area'] is None):
            raise ValueError("Missing the required parameter `delivery_area` when calling `get_capacities`")  # noqa: E501
        # verify the required parameter 'delivery_from' is set
        if ('delivery_from' not in params or
                params['delivery_from'] is None):
            raise ValueError("Missing the required parameter `delivery_from` when calling `get_capacities`")  # noqa: E501
        # verify the required parameter 'delivery_to' is set
        if ('delivery_to' not in params or
                params['delivery_to'] is None):
            raise ValueError("Missing the required parameter `delivery_to` when calling `get_capacities`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'delivery_area' in params:
            query_params.append(('delivery_area', params['delivery_area']))  # noqa: E501
            collection_formats['delivery_area'] = 'csv'  # noqa: E501
        if 'delivery_from' in params:
            query_params.append(('delivery_from', params['delivery_from']))  # noqa: E501
        if 'delivery_to' in params:
            query_params.append(('delivery_to', params['delivery_to']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['api_key_security']  # noqa: E501

        return self.api_client.call_api(
            '/capacities', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Capacity]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
