# coding: utf-8

"""
    PowerBot - Webservice for algotrading

    # TERMS AND CONDITIONS The Powerbot system provides B2B services for trading at intraday power markets. By using the Powerbot service, each user agrees to the terms and conditions of this licence: 1. The user confirms that he/she is familiar with the exchanges trading system and all relevant rules, is professionally qualified and in possession of a trading license for the relevant exchange. 2. The user will comply with the exchanges market rules (e.g. [EPEX Spot Market Rules](https://www.epexspot.com/en/extras/download-center/documentation) or [Nord Pool Market Rules](https://www.nordpoolgroup.com/trading/Rules-and-regulations/)) and will not endanger the exchange system at any time with heavy load from trading algorithms or by other use. 3. The user is aware of OTR (order-to-trade) limits and other limits imposed by the exchange. 4. The user is solely liable for actions resulting from the use of PowerBot.   # INTRODUCTION Powerbot is a web-based software service enabling algorithmic trading on intraday power exchanges such as EPEX, Nord Pool, HUPX, BSP Southpool or TGE. The service is straightforward to integrate in an existing software environment and provides a variety of programming interfaces for development of individual trading algorithms and software tools. Besides enabling fully automated intraday trading, it can be used to create tools for human traders providing relevant information and trading opportunities or can be integrated in existing software tools. For further details see https://www.powerbot-trading.com  ## DOCUMENTATION  In addition to this API guide, please find the documentation at https://docs.powerbot-trading.com - the password will be provided by the PowerBot team. If not, please reach out to us at support@powerbot-trading.com  ## Endpoints The Powerbot service is available at the following REST endpoints:  | Instance                | Base URL for REST Endpoints                                           | |-------------------------|-----------------------------------------------------------------------| | Test (EPEX)             | https://staging.powerbot-trading.com/playground/epex/v2/api           | | Test (Nord Pool)        | https://staging.powerbot-trading.com/playground/nordpool/v2/api       | | Test (HUPX)             | https://staging.powerbot-trading.com/playground/hupx/v2/api           | | Test (BSP Southpool)    | https://staging.powerbot-trading.com/playground/southpool/v2/api      | | Test (TGE)              | https://staging.powerbot-trading.com/playground/tge/v2/api            | | Test (IBEX)             | https://staging.powerbot-trading.com/playground/ibex/v2/api           | | Test (CROPEX)           | https://staging.powerbot-trading.com/playground/cropex/v2/api         | | Staging, Production     | Provided on request                                                   |  Access to endpoints is secured via an API Key, which needs to be passed as an \"api_key\" header in each request.   Notes on API Keys:  * API keys are specific to Test, Staging or Production.  * API keys are generated by the system administrator and need to be requested.  ## How to generate API clients (libraries) The API provides automated generation of API clients (programming libraries) for a wide range of programming languages. To generate them, please open Swagger Editor from the exchange menu, click on \"Generate Client\" and choose a programming language.  ## Errors The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be in JSON format as follows:  ``` {   \"message\": \"... an error message ...\" } ```  ## Paging The API uses offset and limit parameters for paged operations. An X-Total-Count header is added to responses to indicate the total number of items in a paged response.  ## Cross-Origin Resource Sharing This API features Cross-Origin Resource Sharing (CORS) implemented in compliance with  [W3C spec](https://www.w3.org/TR/cors/). This allows cross-domain communication from the browser. All responses have a wildcard same-origin which makes them completely public and accessible to everyone, including any code on any site.  ## API Rate Limiting The API limits the number of concurrent calls to 50 - when that limit is reached, the client will receive 503 http status codes (service unavailable) with the following text:  ``` {   \"message\": \"API rate limit exceeded\" } ``` Clients should ensure that they stay within the limit for concurrent API calls.  ## Additional code samples Additional information and code samples demonstrating the use of the API can be found at https://github.com/powerbot-trading.  # noqa: E501

    OpenAPI spec version: 2.1.25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class ApiKeyDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'type': 'str',
        'tenant_id': 'str',
        'tenant_name': 'str',
        'portfolios': 'list[AvailablePortfolio]',
        'tenant_risk_settings': 'RiskManagementSettings',
        'can_read': 'bool',
        'can_trade': 'bool',
        'can_signal': 'bool'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'type': 'type',
        'tenant_id': 'tenant_id',
        'tenant_name': 'tenant_name',
        'portfolios': 'portfolios',
        'tenant_risk_settings': 'tenant_risk_settings',
        'can_read': 'can_read',
        'can_trade': 'can_trade',
        'can_signal': 'can_signal'
    }

    def __init__(self, name=None, description=None, type=None, tenant_id=None, tenant_name=None, portfolios=None, tenant_risk_settings=None, can_read=None, can_trade=None, can_signal=None):  # noqa: E501
        """ApiKeyDetails - a model defined in Swagger"""  # noqa: E501

        self._name = None
        self._description = None
        self._type = None
        self._tenant_id = None
        self._tenant_name = None
        self._portfolios = None
        self._tenant_risk_settings = None
        self._can_read = None
        self._can_trade = None
        self._can_signal = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if type is not None:
            self.type = type
        if tenant_id is not None:
            self.tenant_id = tenant_id
        if tenant_name is not None:
            self.tenant_name = tenant_name
        if portfolios is not None:
            self.portfolios = portfolios
        if tenant_risk_settings is not None:
            self.tenant_risk_settings = tenant_risk_settings
        if can_read is not None:
            self.can_read = can_read
        if can_trade is not None:
            self.can_trade = can_trade
        if can_signal is not None:
            self.can_signal = can_signal

    @property
    def name(self):
        """Gets the name of this ApiKeyDetails.  # noqa: E501

        A name for the API key, i.e. \"K1\"  # noqa: E501

        :return: The name of this ApiKeyDetails.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ApiKeyDetails.

        A name for the API key, i.e. \"K1\"  # noqa: E501

        :param name: The name of this ApiKeyDetails.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this ApiKeyDetails.  # noqa: E501


        :return: The description of this ApiKeyDetails.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ApiKeyDetails.


        :param description: The description of this ApiKeyDetails.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def type(self):
        """Gets the type of this ApiKeyDetails.  # noqa: E501


        :return: The type of this ApiKeyDetails.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ApiKeyDetails.


        :param type: The type of this ApiKeyDetails.  # noqa: E501
        :type: str
        """
        allowed_values = ["MASTER_API_KEY", "STANDARD_API_KEY", "TENANT_MASTER_API_KEY", "SCHEDULING_API_KEY"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def tenant_id(self):
        """Gets the tenant_id of this ApiKeyDetails.  # noqa: E501


        :return: The tenant_id of this ApiKeyDetails.  # noqa: E501
        :rtype: str
        """
        return self._tenant_id

    @tenant_id.setter
    def tenant_id(self, tenant_id):
        """Sets the tenant_id of this ApiKeyDetails.


        :param tenant_id: The tenant_id of this ApiKeyDetails.  # noqa: E501
        :type: str
        """

        self._tenant_id = tenant_id

    @property
    def tenant_name(self):
        """Gets the tenant_name of this ApiKeyDetails.  # noqa: E501


        :return: The tenant_name of this ApiKeyDetails.  # noqa: E501
        :rtype: str
        """
        return self._tenant_name

    @tenant_name.setter
    def tenant_name(self, tenant_name):
        """Sets the tenant_name of this ApiKeyDetails.


        :param tenant_name: The tenant_name of this ApiKeyDetails.  # noqa: E501
        :type: str
        """

        self._tenant_name = tenant_name

    @property
    def portfolios(self):
        """Gets the portfolios of this ApiKeyDetails.  # noqa: E501


        :return: The portfolios of this ApiKeyDetails.  # noqa: E501
        :rtype: list[AvailablePortfolio]
        """
        return self._portfolios

    @portfolios.setter
    def portfolios(self, portfolios):
        """Sets the portfolios of this ApiKeyDetails.


        :param portfolios: The portfolios of this ApiKeyDetails.  # noqa: E501
        :type: list[AvailablePortfolio]
        """

        self._portfolios = portfolios

    @property
    def tenant_risk_settings(self):
        """Gets the tenant_risk_settings of this ApiKeyDetails.  # noqa: E501


        :return: The tenant_risk_settings of this ApiKeyDetails.  # noqa: E501
        :rtype: RiskManagementSettings
        """
        return self._tenant_risk_settings

    @tenant_risk_settings.setter
    def tenant_risk_settings(self, tenant_risk_settings):
        """Sets the tenant_risk_settings of this ApiKeyDetails.


        :param tenant_risk_settings: The tenant_risk_settings of this ApiKeyDetails.  # noqa: E501
        :type: RiskManagementSettings
        """

        self._tenant_risk_settings = tenant_risk_settings

    @property
    def can_read(self):
        """Gets the can_read of this ApiKeyDetails.  # noqa: E501

        Set to true, if the API key should be able to read data from the exchange (order-book, trades, etc.)  # noqa: E501

        :return: The can_read of this ApiKeyDetails.  # noqa: E501
        :rtype: bool
        """
        return self._can_read

    @can_read.setter
    def can_read(self, can_read):
        """Sets the can_read of this ApiKeyDetails.

        Set to true, if the API key should be able to read data from the exchange (order-book, trades, etc.)  # noqa: E501

        :param can_read: The can_read of this ApiKeyDetails.  # noqa: E501
        :type: bool
        """

        self._can_read = can_read

    @property
    def can_trade(self):
        """Gets the can_trade of this ApiKeyDetails.  # noqa: E501

        Set to true, if the API key should be able to trade.  # noqa: E501

        :return: The can_trade of this ApiKeyDetails.  # noqa: E501
        :rtype: bool
        """
        return self._can_trade

    @can_trade.setter
    def can_trade(self, can_trade):
        """Sets the can_trade of this ApiKeyDetails.

        Set to true, if the API key should be able to trade.  # noqa: E501

        :param can_trade: The can_trade of this ApiKeyDetails.  # noqa: E501
        :type: bool
        """

        self._can_trade = can_trade

    @property
    def can_signal(self):
        """Gets the can_signal of this ApiKeyDetails.  # noqa: E501

        Set to true, if the API key should be allowed to submit signals  # noqa: E501

        :return: The can_signal of this ApiKeyDetails.  # noqa: E501
        :rtype: bool
        """
        return self._can_signal

    @can_signal.setter
    def can_signal(self, can_signal):
        """Sets the can_signal of this ApiKeyDetails.

        Set to true, if the API key should be allowed to submit signals  # noqa: E501

        :param can_signal: The can_signal of this ApiKeyDetails.  # noqa: E501
        :type: bool
        """

        self._can_signal = can_signal

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiKeyDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiKeyDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
