# coding: utf-8

"""
    PowerBot - Webservice for algotrading

    # TERMS AND CONDITIONS The Powerbot system provides B2B services for trading at intraday power markets. By using the Powerbot service, each user agrees to the terms and conditions of this licence: 1. The user confirms that he/she is familiar with the exchanges trading system and all relevant rules, is professionally qualified and in possession of a trading license for the relevant exchange. 2. The user will comply with the exchanges market rules (e.g. [EPEX Spot Market Rules](https://www.epexspot.com/en/extras/download-center/documentation) or [Nord Pool Market Rules](https://www.nordpoolgroup.com/trading/Rules-and-regulations/)) and will not endanger the exchange system at any time with heavy load from trading algorithms or by other use. 3. The user is aware of OTR (order-to-trade) limits and other limits imposed by the exchange. 4. The user is solely liable for actions resulting from the use of PowerBot.   # INTRODUCTION Powerbot is a web-based software service enabling algorithmic trading on intraday power exchanges such as EPEX, Nord Pool, HUPX, BSP Southpool or TGE. The service is straightforward to integrate in an existing software environment and provides a variety of programming interfaces for development of individual trading algorithms and software tools. Besides enabling fully automated intraday trading, it can be used to create tools for human traders providing relevant information and trading opportunities or can be integrated in existing software tools. For further details see https://www.powerbot-trading.com  ## DOCUMENTATION  In addition to this API guide, please find the documentation at https://docs.powerbot-trading.com - the password will be provided by the PowerBot team. If not, please reach out to us at support@powerbot-trading.com  ## Endpoints The Powerbot service is available at the following REST endpoints:  | Instance                | Base URL for REST Endpoints                                           | |-------------------------|-----------------------------------------------------------------------| | Test (EPEX)             | https://staging.powerbot-trading.com/playground/epex/v2/api           | | Test (Nord Pool)        | https://staging.powerbot-trading.com/playground/nordpool/v2/api       | | Test (HUPX)             | https://staging.powerbot-trading.com/playground/hupx/v2/api           | | Test (BSP Southpool)    | https://staging.powerbot-trading.com/playground/southpool/v2/api      | | Test (TGE)              | https://staging.powerbot-trading.com/playground/tge/v2/api            | | Test (IBEX)             | https://staging.powerbot-trading.com/playground/ibex/v2/api           | | Test (CROPEX)           | https://staging.powerbot-trading.com/playground/cropex/v2/api         | | Staging, Production     | Provided on request                                                   |  Access to endpoints is secured via an API Key, which needs to be passed as an \"api_key\" header in each request.   Notes on API Keys:  * API keys are specific to Test, Staging or Production.  * API keys are generated by the system administrator and need to be requested.  ## How to generate API clients (libraries) The API provides automated generation of API clients (programming libraries) for a wide range of programming languages. To generate them, please open Swagger Editor from the exchange menu, click on \"Generate Client\" and choose a programming language.  ## Errors The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be in JSON format as follows:  ``` {   \"message\": \"... an error message ...\" } ```  ## Paging The API uses offset and limit parameters for paged operations. An X-Total-Count header is added to responses to indicate the total number of items in a paged response.  ## Cross-Origin Resource Sharing This API features Cross-Origin Resource Sharing (CORS) implemented in compliance with  [W3C spec](https://www.w3.org/TR/cors/). This allows cross-domain communication from the browser. All responses have a wildcard same-origin which makes them completely public and accessible to everyone, including any code on any site.  ## API Rate Limiting The API limits the number of concurrent calls to 50 - when that limit is reached, the client will receive 503 http status codes (service unavailable) with the following text:  ``` {   \"message\": \"API rate limit exceeded\" } ``` Clients should ensure that they stay within the limit for concurrent API calls.  ## Additional code samples Additional information and code samples demonstrating the use of the API can be found at https://github.com/powerbot-trading.  # noqa: E501

    OpenAPI spec version: 2.1.25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class OrderBookChangedEvent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'message_class': 'str',
        'portfolio_id': 'str',
        'emitted_at': 'datetime',
        'contract_id': 'str',
        'contract_type': 'str',
        'delivery_area': 'str',
        'delivery_start': 'datetime',
        'delivery_end': 'datetime',
        'active_since': 'datetime',
        'revision': 'int',
        'sequence_number': 'int'
    }

    attribute_map = {
        'message_class': 'messageClass',
        'portfolio_id': 'portfolio_id',
        'emitted_at': 'emittedAt',
        'contract_id': 'contract_id',
        'contract_type': 'contract_type',
        'delivery_area': 'delivery_area',
        'delivery_start': 'delivery_start',
        'delivery_end': 'delivery_end',
        'active_since': 'active_since',
        'revision': 'revision',
        'sequence_number': 'sequence_number'
    }

    def __init__(self, message_class=None, portfolio_id=None, emitted_at=None, contract_id=None, contract_type=None, delivery_area=None, delivery_start=None, delivery_end=None, active_since=None, revision=None, sequence_number=None):  # noqa: E501
        """OrderBookChangedEvent - a model defined in Swagger"""  # noqa: E501

        self._message_class = None
        self._portfolio_id = None
        self._emitted_at = None
        self._contract_id = None
        self._contract_type = None
        self._delivery_area = None
        self._delivery_start = None
        self._delivery_end = None
        self._active_since = None
        self._revision = None
        self._sequence_number = None
        self.discriminator = None

        if message_class is not None:
            self.message_class = message_class
        if portfolio_id is not None:
            self.portfolio_id = portfolio_id
        if emitted_at is not None:
            self.emitted_at = emitted_at
        if contract_id is not None:
            self.contract_id = contract_id
        if contract_type is not None:
            self.contract_type = contract_type
        if delivery_area is not None:
            self.delivery_area = delivery_area
        if delivery_start is not None:
            self.delivery_start = delivery_start
        if delivery_end is not None:
            self.delivery_end = delivery_end
        if active_since is not None:
            self.active_since = active_since
        if revision is not None:
            self.revision = revision
        if sequence_number is not None:
            self.sequence_number = sequence_number

    @property
    def message_class(self):
        """Gets the message_class of this OrderBookChangedEvent.  # noqa: E501


        :return: The message_class of this OrderBookChangedEvent.  # noqa: E501
        :rtype: str
        """
        return self._message_class

    @message_class.setter
    def message_class(self, message_class):
        """Sets the message_class of this OrderBookChangedEvent.


        :param message_class: The message_class of this OrderBookChangedEvent.  # noqa: E501
        :type: str
        """

        self._message_class = message_class

    @property
    def portfolio_id(self):
        """Gets the portfolio_id of this OrderBookChangedEvent.  # noqa: E501


        :return: The portfolio_id of this OrderBookChangedEvent.  # noqa: E501
        :rtype: str
        """
        return self._portfolio_id

    @portfolio_id.setter
    def portfolio_id(self, portfolio_id):
        """Sets the portfolio_id of this OrderBookChangedEvent.


        :param portfolio_id: The portfolio_id of this OrderBookChangedEvent.  # noqa: E501
        :type: str
        """

        self._portfolio_id = portfolio_id

    @property
    def emitted_at(self):
        """Gets the emitted_at of this OrderBookChangedEvent.  # noqa: E501


        :return: The emitted_at of this OrderBookChangedEvent.  # noqa: E501
        :rtype: datetime
        """
        return self._emitted_at

    @emitted_at.setter
    def emitted_at(self, emitted_at):
        """Sets the emitted_at of this OrderBookChangedEvent.


        :param emitted_at: The emitted_at of this OrderBookChangedEvent.  # noqa: E501
        :type: datetime
        """

        self._emitted_at = emitted_at

    @property
    def contract_id(self):
        """Gets the contract_id of this OrderBookChangedEvent.  # noqa: E501


        :return: The contract_id of this OrderBookChangedEvent.  # noqa: E501
        :rtype: str
        """
        return self._contract_id

    @contract_id.setter
    def contract_id(self, contract_id):
        """Sets the contract_id of this OrderBookChangedEvent.


        :param contract_id: The contract_id of this OrderBookChangedEvent.  # noqa: E501
        :type: str
        """

        self._contract_id = contract_id

    @property
    def contract_type(self):
        """Gets the contract_type of this OrderBookChangedEvent.  # noqa: E501


        :return: The contract_type of this OrderBookChangedEvent.  # noqa: E501
        :rtype: str
        """
        return self._contract_type

    @contract_type.setter
    def contract_type(self, contract_type):
        """Sets the contract_type of this OrderBookChangedEvent.


        :param contract_type: The contract_type of this OrderBookChangedEvent.  # noqa: E501
        :type: str
        """
        allowed_values = ["PDC", "UDC", "ALL"]  # noqa: E501
        if contract_type not in allowed_values:
            raise ValueError(
                "Invalid value for `contract_type` ({0}), must be one of {1}"  # noqa: E501
                .format(contract_type, allowed_values)
            )

        self._contract_type = contract_type

    @property
    def delivery_area(self):
        """Gets the delivery_area of this OrderBookChangedEvent.  # noqa: E501


        :return: The delivery_area of this OrderBookChangedEvent.  # noqa: E501
        :rtype: str
        """
        return self._delivery_area

    @delivery_area.setter
    def delivery_area(self, delivery_area):
        """Sets the delivery_area of this OrderBookChangedEvent.


        :param delivery_area: The delivery_area of this OrderBookChangedEvent.  # noqa: E501
        :type: str
        """

        self._delivery_area = delivery_area

    @property
    def delivery_start(self):
        """Gets the delivery_start of this OrderBookChangedEvent.  # noqa: E501


        :return: The delivery_start of this OrderBookChangedEvent.  # noqa: E501
        :rtype: datetime
        """
        return self._delivery_start

    @delivery_start.setter
    def delivery_start(self, delivery_start):
        """Sets the delivery_start of this OrderBookChangedEvent.


        :param delivery_start: The delivery_start of this OrderBookChangedEvent.  # noqa: E501
        :type: datetime
        """

        self._delivery_start = delivery_start

    @property
    def delivery_end(self):
        """Gets the delivery_end of this OrderBookChangedEvent.  # noqa: E501


        :return: The delivery_end of this OrderBookChangedEvent.  # noqa: E501
        :rtype: datetime
        """
        return self._delivery_end

    @delivery_end.setter
    def delivery_end(self, delivery_end):
        """Sets the delivery_end of this OrderBookChangedEvent.


        :param delivery_end: The delivery_end of this OrderBookChangedEvent.  # noqa: E501
        :type: datetime
        """

        self._delivery_end = delivery_end

    @property
    def active_since(self):
        """Gets the active_since of this OrderBookChangedEvent.  # noqa: E501

        The timestamp (UTC) since when the contract has been observed as active for trading in the corresponding delivery area. Is reset to current time after a system or market outage or after the market was hibernated. Can be used to determine potential low liquidity situations after activation of new contracts or market outages.  # noqa: E501

        :return: The active_since of this OrderBookChangedEvent.  # noqa: E501
        :rtype: datetime
        """
        return self._active_since

    @active_since.setter
    def active_since(self, active_since):
        """Sets the active_since of this OrderBookChangedEvent.

        The timestamp (UTC) since when the contract has been observed as active for trading in the corresponding delivery area. Is reset to current time after a system or market outage or after the market was hibernated. Can be used to determine potential low liquidity situations after activation of new contracts or market outages.  # noqa: E501

        :param active_since: The active_since of this OrderBookChangedEvent.  # noqa: E501
        :type: datetime
        """

        self._active_since = active_since

    @property
    def revision(self):
        """Gets the revision of this OrderBookChangedEvent.  # noqa: E501


        :return: The revision of this OrderBookChangedEvent.  # noqa: E501
        :rtype: int
        """
        return self._revision

    @revision.setter
    def revision(self, revision):
        """Sets the revision of this OrderBookChangedEvent.


        :param revision: The revision of this OrderBookChangedEvent.  # noqa: E501
        :type: int
        """

        self._revision = revision

    @property
    def sequence_number(self):
        """Gets the sequence_number of this OrderBookChangedEvent.  # noqa: E501

        Running number within one delivery area  # noqa: E501

        :return: The sequence_number of this OrderBookChangedEvent.  # noqa: E501
        :rtype: int
        """
        return self._sequence_number

    @sequence_number.setter
    def sequence_number(self, sequence_number):
        """Sets the sequence_number of this OrderBookChangedEvent.

        Running number within one delivery area  # noqa: E501

        :param sequence_number: The sequence_number of this OrderBookChangedEvent.  # noqa: E501
        :type: int
        """

        self._sequence_number = sequence_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OrderBookChangedEvent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrderBookChangedEvent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
