# coding: utf-8

"""
    PowerBot - Webservice for algotrading

    # TERMS AND CONDITIONS The Powerbot system provides B2B services for trading at intraday power markets. By using the Powerbot service, each user agrees to the terms and conditions of this licence: 1. The user confirms that he/she is familiar with the exchanges trading system and all relevant rules, is professionally qualified and in possession of a trading license for the relevant exchange. 2. The user will comply with the exchanges market rules (e.g. [EPEX Spot Market Rules](https://www.epexspot.com/en/extras/download-center/documentation) or [Nord Pool Market Rules](https://www.nordpoolgroup.com/trading/Rules-and-regulations/)) and will not endanger the exchange system at any time with heavy load from trading algorithms or by other use. 3. The user is aware of OTR (order-to-trade) limits and other limits imposed by the exchange. 4. The user is solely liable for actions resulting from the use of PowerBot.   # INTRODUCTION Powerbot is a web-based software service enabling algorithmic trading on intraday power exchanges such as EPEX, Nord Pool, HUPX, BSP Southpool or TGE. The service is straightforward to integrate in an existing software environment and provides a variety of programming interfaces for development of individual trading algorithms and software tools. Besides enabling fully automated intraday trading, it can be used to create tools for human traders providing relevant information and trading opportunities or can be integrated in existing software tools. For further details see https://www.powerbot-trading.com  ## DOCUMENTATION  In addition to this API guide, please find the documentation at https://docs.powerbot-trading.com - the password will be provided by the PowerBot team. If not, please reach out to us at support@powerbot-trading.com  ## Endpoints The Powerbot service is available at the following REST endpoints:  | Instance                | Base URL for REST Endpoints                                           | |-------------------------|-----------------------------------------------------------------------| | Test (EPEX)             | https://staging.powerbot-trading.com/playground/epex/v2/api           | | Test (Nord Pool)        | https://staging.powerbot-trading.com/playground/nordpool/v2/api       | | Test (HUPX)             | https://staging.powerbot-trading.com/playground/hupx/v2/api           | | Test (BSP Southpool)    | https://staging.powerbot-trading.com/playground/southpool/v2/api      | | Test (TGE)              | https://staging.powerbot-trading.com/playground/tge/v2/api            | | Test (IBEX)             | https://staging.powerbot-trading.com/playground/ibex/v2/api           | | Test (CROPEX)           | https://staging.powerbot-trading.com/playground/cropex/v2/api         | | Staging, Production     | Provided on request                                                   |  Access to endpoints is secured via an API Key, which needs to be passed as an \"api_key\" header in each request.   Notes on API Keys:  * API keys are specific to Test, Staging or Production.  * API keys are generated by the system administrator and need to be requested.  ## How to generate API clients (libraries) The API provides automated generation of API clients (programming libraries) for a wide range of programming languages. To generate them, please open Swagger Editor from the exchange menu, click on \"Generate Client\" and choose a programming language.  ## Errors The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be in JSON format as follows:  ``` {   \"message\": \"... an error message ...\" } ```  ## Paging The API uses offset and limit parameters for paged operations. An X-Total-Count header is added to responses to indicate the total number of items in a paged response.  ## Cross-Origin Resource Sharing This API features Cross-Origin Resource Sharing (CORS) implemented in compliance with  [W3C spec](https://www.w3.org/TR/cors/). This allows cross-domain communication from the browser. All responses have a wildcard same-origin which makes them completely public and accessible to everyone, including any code on any site.  ## API Rate Limiting The API limits the number of concurrent calls to 50 - when that limit is reached, the client will receive 503 http status codes (service unavailable) with the following text:  ``` {   \"message\": \"API rate limit exceeded\" } ``` Clients should ensure that they stay within the limit for concurrent API calls.  ## Additional code samples Additional information and code samples demonstrating the use of the API can be found at https://github.com/powerbot-trading.  # noqa: E501

    OpenAPI spec version: 2.1.25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class Signal(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'source': 'str',
        'received_at': 'datetime',
        'revision': 'int',
        'delivery_start': 'datetime',
        'delivery_end': 'datetime',
        'delivery_areas': 'list[str]',
        'portfolio_ids': 'list[str]',
        'tenant_id': 'str',
        'position_short': 'float',
        'position_long': 'float',
        'value': 'object'
    }

    attribute_map = {
        'id': 'id',
        'source': 'source',
        'received_at': 'received_at',
        'revision': 'revision',
        'delivery_start': 'delivery_start',
        'delivery_end': 'delivery_end',
        'delivery_areas': 'delivery_areas',
        'portfolio_ids': 'portfolio_ids',
        'tenant_id': 'tenant_id',
        'position_short': 'position_short',
        'position_long': 'position_long',
        'value': 'value'
    }

    def __init__(self, id=None, source=None, received_at=None, revision=None, delivery_start=None, delivery_end=None, delivery_areas=None, portfolio_ids=None, tenant_id=None, position_short=None, position_long=None, value=None):  # noqa: E501
        """Signal - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._source = None
        self._received_at = None
        self._revision = None
        self._delivery_start = None
        self._delivery_end = None
        self._delivery_areas = None
        self._portfolio_ids = None
        self._tenant_id = None
        self._position_short = None
        self._position_long = None
        self._value = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if source is not None:
            self.source = source
        if received_at is not None:
            self.received_at = received_at
        if revision is not None:
            self.revision = revision
        if delivery_start is not None:
            self.delivery_start = delivery_start
        if delivery_end is not None:
            self.delivery_end = delivery_end
        if delivery_areas is not None:
            self.delivery_areas = delivery_areas
        if portfolio_ids is not None:
            self.portfolio_ids = portfolio_ids
        if tenant_id is not None:
            self.tenant_id = tenant_id
        if position_short is not None:
            self.position_short = position_short
        if position_long is not None:
            self.position_long = position_long
        if value is not None:
            self.value = value

    @property
    def id(self):
        """Gets the id of this Signal.  # noqa: E501

        The unique id of the signal (within the namespace of the emitting source)  # noqa: E501

        :return: The id of this Signal.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Signal.

        The unique id of the signal (within the namespace of the emitting source)  # noqa: E501

        :param id: The id of this Signal.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def source(self):
        """Gets the source of this Signal.  # noqa: E501

        The identifier of the system which emitted the signal  # noqa: E501

        :return: The source of this Signal.  # noqa: E501
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this Signal.

        The identifier of the system which emitted the signal  # noqa: E501

        :param source: The source of this Signal.  # noqa: E501
        :type: str
        """

        self._source = source

    @property
    def received_at(self):
        """Gets the received_at of this Signal.  # noqa: E501

        The timestamp when the signal was received  # noqa: E501

        :return: The received_at of this Signal.  # noqa: E501
        :rtype: datetime
        """
        return self._received_at

    @received_at.setter
    def received_at(self, received_at):
        """Sets the received_at of this Signal.

        The timestamp when the signal was received  # noqa: E501

        :param received_at: The received_at of this Signal.  # noqa: E501
        :type: datetime
        """

        self._received_at = received_at

    @property
    def revision(self):
        """Gets the revision of this Signal.  # noqa: E501

        The number of times the signal has been updated. If the signal has never received any updates, then revision is 0.  # noqa: E501

        :return: The revision of this Signal.  # noqa: E501
        :rtype: int
        """
        return self._revision

    @revision.setter
    def revision(self, revision):
        """Sets the revision of this Signal.

        The number of times the signal has been updated. If the signal has never received any updates, then revision is 0.  # noqa: E501

        :param revision: The revision of this Signal.  # noqa: E501
        :type: int
        """

        self._revision = revision

    @property
    def delivery_start(self):
        """Gets the delivery_start of this Signal.  # noqa: E501

        Together with delivery_start and delivery_end specify the delivery period in which the signal is valid  # noqa: E501

        :return: The delivery_start of this Signal.  # noqa: E501
        :rtype: datetime
        """
        return self._delivery_start

    @delivery_start.setter
    def delivery_start(self, delivery_start):
        """Sets the delivery_start of this Signal.

        Together with delivery_start and delivery_end specify the delivery period in which the signal is valid  # noqa: E501

        :param delivery_start: The delivery_start of this Signal.  # noqa: E501
        :type: datetime
        """

        self._delivery_start = delivery_start

    @property
    def delivery_end(self):
        """Gets the delivery_end of this Signal.  # noqa: E501

        Together with delivery_start and delivery_end specify the delivery period in which the signal is valid  # noqa: E501

        :return: The delivery_end of this Signal.  # noqa: E501
        :rtype: datetime
        """
        return self._delivery_end

    @delivery_end.setter
    def delivery_end(self, delivery_end):
        """Sets the delivery_end of this Signal.

        Together with delivery_start and delivery_end specify the delivery period in which the signal is valid  # noqa: E501

        :param delivery_end: The delivery_end of this Signal.  # noqa: E501
        :type: datetime
        """

        self._delivery_end = delivery_end

    @property
    def delivery_areas(self):
        """Gets the delivery_areas of this Signal.  # noqa: E501

        The EIC code of the delivery areas for which the signal is applicable  # noqa: E501

        :return: The delivery_areas of this Signal.  # noqa: E501
        :rtype: list[str]
        """
        return self._delivery_areas

    @delivery_areas.setter
    def delivery_areas(self, delivery_areas):
        """Sets the delivery_areas of this Signal.

        The EIC code of the delivery areas for which the signal is applicable  # noqa: E501

        :param delivery_areas: The delivery_areas of this Signal.  # noqa: E501
        :type: list[str]
        """

        self._delivery_areas = delivery_areas

    @property
    def portfolio_ids(self):
        """Gets the portfolio_ids of this Signal.  # noqa: E501

        The portfolios for which the signal is applicable  # noqa: E501

        :return: The portfolio_ids of this Signal.  # noqa: E501
        :rtype: list[str]
        """
        return self._portfolio_ids

    @portfolio_ids.setter
    def portfolio_ids(self, portfolio_ids):
        """Sets the portfolio_ids of this Signal.

        The portfolios for which the signal is applicable  # noqa: E501

        :param portfolio_ids: The portfolio_ids of this Signal.  # noqa: E501
        :type: list[str]
        """

        self._portfolio_ids = portfolio_ids

    @property
    def tenant_id(self):
        """Gets the tenant_id of this Signal.  # noqa: E501


        :return: The tenant_id of this Signal.  # noqa: E501
        :rtype: str
        """
        return self._tenant_id

    @tenant_id.setter
    def tenant_id(self, tenant_id):
        """Sets the tenant_id of this Signal.


        :param tenant_id: The tenant_id of this Signal.  # noqa: E501
        :type: str
        """

        self._tenant_id = tenant_id

    @property
    def position_short(self):
        """Gets the position_short of this Signal.  # noqa: E501


        :return: The position_short of this Signal.  # noqa: E501
        :rtype: float
        """
        return self._position_short

    @position_short.setter
    def position_short(self, position_short):
        """Sets the position_short of this Signal.


        :param position_short: The position_short of this Signal.  # noqa: E501
        :type: float
        """

        self._position_short = position_short

    @property
    def position_long(self):
        """Gets the position_long of this Signal.  # noqa: E501


        :return: The position_long of this Signal.  # noqa: E501
        :rtype: float
        """
        return self._position_long

    @position_long.setter
    def position_long(self, position_long):
        """Sets the position_long of this Signal.


        :param position_long: The position_long of this Signal.  # noqa: E501
        :type: float
        """

        self._position_long = position_long

    @property
    def value(self):
        """Gets the value of this Signal.  # noqa: E501

        The custom content of the signal  # noqa: E501

        :return: The value of this Signal.  # noqa: E501
        :rtype: object
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this Signal.

        The custom content of the signal  # noqa: E501

        :param value: The value of this Signal.  # noqa: E501
        :type: object
        """

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Signal, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Signal):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
