# coding: utf-8

"""
    PowerBot - Webservice for algotrading

    # TERMS AND CONDITIONS The Powerbot system provides B2B services for trading at intraday power markets. By using the Powerbot service, each user agrees to the terms and conditions of this licence: 1. The user confirms that he/she is familiar with the exchanges trading system and all relevant rules, is professionally qualified and in possession of a trading license for the relevant exchange. 2. The user will comply with the exchanges market rules (e.g. [EPEX Spot Market Rules](https://www.epexspot.com/en/extras/download-center/documentation) or [Nord Pool Market Rules](https://www.nordpoolgroup.com/trading/Rules-and-regulations/)) and will not endanger the exchange system at any time with heavy load from trading algorithms or by other use. 3. The user is aware of OTR (order-to-trade) limits and other limits imposed by the exchange. 4. The user is solely liable for actions resulting from the use of PowerBot.   # INTRODUCTION Powerbot is a web-based software service enabling algorithmic trading on intraday power exchanges such as EPEX, Nord Pool, HUPX, BSP Southpool or TGE. The service is straightforward to integrate in an existing software environment and provides a variety of programming interfaces for development of individual trading algorithms and software tools. Besides enabling fully automated intraday trading, it can be used to create tools for human traders providing relevant information and trading opportunities or can be integrated in existing software tools. For further details see https://www.powerbot-trading.com  ## DOCUMENTATION  In addition to this API guide, please find the documentation at https://docs.powerbot-trading.com - the password will be provided by the PowerBot team. If not, please reach out to us at support@powerbot-trading.com  ## Endpoints The Powerbot service is available at the following REST endpoints:  | Instance                | Base URL for REST Endpoints                                           | |-------------------------|-----------------------------------------------------------------------| | Test (EPEX)             | https://staging.powerbot-trading.com/playground/epex/v2/api           | | Test (Nord Pool)        | https://staging.powerbot-trading.com/playground/nordpool/v2/api       | | Test (HUPX)             | https://staging.powerbot-trading.com/playground/hupx/v2/api           | | Test (BSP Southpool)    | https://staging.powerbot-trading.com/playground/southpool/v2/api      | | Test (TGE)              | https://staging.powerbot-trading.com/playground/tge/v2/api            | | Test (IBEX)             | https://staging.powerbot-trading.com/playground/ibex/v2/api           | | Test (CROPEX)           | https://staging.powerbot-trading.com/playground/cropex/v2/api         | | Staging, Production     | Provided on request                                                   |  Access to endpoints is secured via an API Key, which needs to be passed as an \"api_key\" header in each request.   Notes on API Keys:  * API keys are specific to Test, Staging or Production.  * API keys are generated by the system administrator and need to be requested.  ## How to generate API clients (libraries) The API provides automated generation of API clients (programming libraries) for a wide range of programming languages. To generate them, please open Swagger Editor from the exchange menu, click on \"Generate Client\" and choose a programming language.  ## Errors The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be in JSON format as follows:  ``` {   \"message\": \"... an error message ...\" } ```  ## Paging The API uses offset and limit parameters for paged operations. An X-Total-Count header is added to responses to indicate the total number of items in a paged response.  ## Cross-Origin Resource Sharing This API features Cross-Origin Resource Sharing (CORS) implemented in compliance with  [W3C spec](https://www.w3.org/TR/cors/). This allows cross-domain communication from the browser. All responses have a wildcard same-origin which makes them completely public and accessible to everyone, including any code on any site.  ## API Rate Limiting The API limits the number of concurrent calls to 50 - when that limit is reached, the client will receive 503 http status codes (service unavailable) with the following text:  ``` {   \"message\": \"API rate limit exceeded\" } ``` Clients should ensure that they stay within the limit for concurrent API calls.  ## Additional code samples Additional information and code samples demonstrating the use of the API can be found at https://github.com/powerbot-trading.  # noqa: E501

    OpenAPI spec version: 2.1.25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class UpdateStatus(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'delivery_area': 'str',
        'order_mod_type': 'str',
        'incl_pre_arranged': 'bool',
        'prod_name': 'list[str]'
    }

    attribute_map = {
        'delivery_area': 'delivery_area',
        'order_mod_type': 'orderModType',
        'incl_pre_arranged': 'inclPreArranged',
        'prod_name': 'prodName'
    }

    def __init__(self, delivery_area=None, order_mod_type=None, incl_pre_arranged=None, prod_name=None):  # noqa: E501
        """UpdateStatus - a model defined in Swagger"""  # noqa: E501

        self._delivery_area = None
        self._order_mod_type = None
        self._incl_pre_arranged = None
        self._prod_name = None
        self.discriminator = None

        self.delivery_area = delivery_area
        self.order_mod_type = order_mod_type
        if incl_pre_arranged is not None:
            self.incl_pre_arranged = incl_pre_arranged
        if prod_name is not None:
            self.prod_name = prod_name

    @property
    def delivery_area(self):
        """Gets the delivery_area of this UpdateStatus.  # noqa: E501


        :return: The delivery_area of this UpdateStatus.  # noqa: E501
        :rtype: str
        """
        return self._delivery_area

    @delivery_area.setter
    def delivery_area(self, delivery_area):
        """Sets the delivery_area of this UpdateStatus.


        :param delivery_area: The delivery_area of this UpdateStatus.  # noqa: E501
        :type: str
        """
        if delivery_area is None:
            raise ValueError("Invalid value for `delivery_area`, must not be `None`")  # noqa: E501

        self._delivery_area = delivery_area

    @property
    def order_mod_type(self):
        """Gets the order_mod_type of this UpdateStatus.  # noqa: E501

        * ACTI: Activates the order. Ignored if already active. * DEAC: Deactivates (hibernates) the order. Hibernated orders are removed from the order book but are still available for modification or activation in the own orders list. * DELE: Delete the order  # noqa: E501

        :return: The order_mod_type of this UpdateStatus.  # noqa: E501
        :rtype: str
        """
        return self._order_mod_type

    @order_mod_type.setter
    def order_mod_type(self, order_mod_type):
        """Sets the order_mod_type of this UpdateStatus.

        * ACTI: Activates the order. Ignored if already active. * DEAC: Deactivates (hibernates) the order. Hibernated orders are removed from the order book but are still available for modification or activation in the own orders list. * DELE: Delete the order  # noqa: E501

        :param order_mod_type: The order_mod_type of this UpdateStatus.  # noqa: E501
        :type: str
        """
        if order_mod_type is None:
            raise ValueError("Invalid value for `order_mod_type`, must not be `None`")  # noqa: E501
        allowed_values = ["ACTI", "DEAC", "DELE"]  # noqa: E501
        if order_mod_type not in allowed_values:
            raise ValueError(
                "Invalid value for `order_mod_type` ({0}), must be one of {1}"  # noqa: E501
                .format(order_mod_type, allowed_values)
            )

        self._order_mod_type = order_mod_type

    @property
    def incl_pre_arranged(self):
        """Gets the incl_pre_arranged of this UpdateStatus.  # noqa: E501

        Include pre-arranged orders (default = false)  # noqa: E501

        :return: The incl_pre_arranged of this UpdateStatus.  # noqa: E501
        :rtype: bool
        """
        return self._incl_pre_arranged

    @incl_pre_arranged.setter
    def incl_pre_arranged(self, incl_pre_arranged):
        """Sets the incl_pre_arranged of this UpdateStatus.

        Include pre-arranged orders (default = false)  # noqa: E501

        :param incl_pre_arranged: The incl_pre_arranged of this UpdateStatus.  # noqa: E501
        :type: bool
        """

        self._incl_pre_arranged = incl_pre_arranged

    @property
    def prod_name(self):
        """Gets the prod_name of this UpdateStatus.  # noqa: E501

        Restrict the request to the given product(s)  # noqa: E501

        :return: The prod_name of this UpdateStatus.  # noqa: E501
        :rtype: list[str]
        """
        return self._prod_name

    @prod_name.setter
    def prod_name(self, prod_name):
        """Sets the prod_name of this UpdateStatus.

        Restrict the request to the given product(s)  # noqa: E501

        :param prod_name: The prod_name of this UpdateStatus.  # noqa: E501
        :type: list[str]
        """

        self._prod_name = prod_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateStatus, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateStatus):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
